import { Component, JSXElement } from 'solid-js';

import { Alert as MuiAlert } from '@suid/material';
import { AlertColor } from '@suid/material/Alert';
import Dialog from '../dialog';

interface Props {
  open: boolean;
  closeHandler: (event: any, reason?: string) => void;
  severity?: AlertColor;
  icon?: JSXElement;
  action?: JSXElement;
  children?: JSXElement;
}

const Alert: Component<Props> = ({
  open,
  closeHandler,
  severity,
  icon,
  action,
  children,
}) => {
  return (
    <Dialog open={open()} closeHandler={closeHandler} maxWidth={false}>
      <MuiAlert severity={severity} icon={icon} action={action}>
        {children}
      </MuiAlert>
    </Dialog>
  );
};

export default Alert;
